<?xml version="1.0" encoding="UTF-8"?> 
<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

  <!-- output the faciltiy code list-->
  <xsl:template match="/">
    <xsl:for-each select="//table">
      <configurationGroup >
	<xsl:attribute name='name'><xsl:value-of select="substring-after(./column[@name='id'],'|')"/></xsl:attribute>
	<configurationGroup name="fields">
	  <xsl:for-each select="./column">
	    <xsl:choose>
	      <xsl:when test=". = 'NULL'">
		<!-- do nothing-->
	      </xsl:when>
	      <xsl:when test="@name = 'id'">
		<!-- do nothing-->
	      </xsl:when>
	      <xsl:when test="@name = 'last_modified'">
		<!-- do nothing-->
	      </xsl:when>
	      <xsl:when test="@name = 'who'">
		<!-- do nothing-->
	      </xsl:when>
	      <xsl:when test="@name = 'parent'">
		<!-- do nothing-->
	      </xsl:when>
	      <xsl:otherwise>
		<configuration>
		  <xsl:attribute name='name'><xsl:value-of select="@name"/></xsl:attribute>
		  <value><xsl:value-of select='.'/></value>
		</configuration>
	      </xsl:otherwise>
	    </xsl:choose>
	  </xsl:for-each>
	</configurationGroup>
	<configuration name='last_modified'>
	  <value><xsl:value-of select='column[@name="last_modified"]'/></value>
	</configuration>
      </configurationGroup>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>

