<?php
/**
 * @copyright © 2007, 2008, 2009 Intrahealth International, Inc.
 * This File is part of I2CE
 *
 * I2CE is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * @package I2CE
 * @author Sovello Hildebrand <smgani@intrahealth.org>
 * @since v3.2.0
 * @version v4.1.8.12
 */
/**
 * This class extends the I2CE_FormField_MAP_MULT class only to override the way
 * the values display when they are more than one
 *
 */
class I2CE_BW_MAP_MULT extends I2CE_FormField_MAP_MULT {


    /**
     * Returns the value of this field as a human readable format.
     * Each value will be on its own line
     * @param I2CE_Entry $entry If a I2CE_Entry object has been passed to this method then it will return the value for that entry assuming it's an
     * entry for this field.
     * @return mixed
     */
      public function getDisplayValue( $entry=false,$style = 'default' ) {
          if ( $entry instanceof I2CE_Entry ) {
              $value = $entry->getValue();
          } else {
              $value = $this->getValue();
          }
          $map_list = array();
          foreach( $value as $map_value ) {
              $map_list[] = I2CE_List::lookup( $map_value[1], $map_value[0] );
          }
          if (count($map_list) > 1){
              return "* ".implode( PHP_EOL."* ", $map_list );
          } else {
              return "* ".implode( "", $map_list );
          }
     }


}

# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
