<?php
/**
* © Copyright 2007 IntraHealth International, Inc.
* 
* This File is part of I2CE 
* 
* I2CE is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License 
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
*  iHRIS_PMH_PageView
* @package I2CE
* @subpackage Site
* @author Sovello Hildebrand <sovellohpmgani@gmail.com>
* @copyright Copyright &copy; 2007 IntraHealth International, Inc. 
* This file is part of I2CE. I2CE is free software; you can redistribute it and/or modify it under 
* the terms of the GNU General Public License as published by the Free Software Foundation; either 
* version 3 of the License, or (at your option) any later version. I2CE is distributed in the hope 
* that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have 
* received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.
* @version 4.1
* @access public
*/


class iHRIS_PMH_PageView extends iHRIS_PageView {
    
    /**
     * Create and load data for the objects used for this form.
     * 
     * Create the list object and if this is a form submission load
     * the data from the form data.  It determines the type based on the
     * {@link $type} member variable.
     */
    protected function action() {
      $last_modified = array();
      $ff = I2CE_FormFactory::instance();
        if($this->request_exists('id')){
            $personid = $this->request('id');
            $personObj=$ff->createContainer($personid);
            $personObj->populate();
            $child_forms = I2CE::getConfig()->getAsArray("/modules/forms/forms/person/meta/child_forms");
            $personObj->populateChildren($child_forms);
            $children = $personObj->getChildren();
            $db = MDB2::singleton();
            foreach ($personObj->getChildren() as $child_form_name=>$child_form_data) {
              foreach ($child_form_data as $child_form_id=>$child_form) {
                    if (!$child_form instanceof I2CE_Form) {
                        continue;
                    }
                    if ($child_form_name == 'person_position' && ($posObj= $ff->createContainer($child_form->getField('position')->getValue())) instanceof iHRIS_Position) {
                      
                        $qryPp = "SELECT last_modified FROM hippo_person_position WHERE parent = '$personid' order by last_modified DESC LIMIT 1";
                        
                        $resPp = $db->query($qryPp);
                        if($resPp ==null)
                         return false;
                        while($row =$resPp->fetchRow())
                        {
                            $last_modified[] = $row->last_modified;
                        }
                        $qry = "SELECT last_modified FROM hippo_position WHERE id = '". $child_form->getField('position')->getDBValue()."' order by last_modified DESC LIMIT 1";
                        I2CE::raiseError($qry);
                        $res = $db->query($qry);
                        $res->setResultTypes( array('text') );
                        if($res ==null)
                         return false;
                        while($row =$res->fetchRow())
                        {
                            $last_modified[] = $row->last_modified;
                        }
                    }
                    $qry2 = "SELECT last_modified FROM hippo_demographic WHERE parent = '$personid' ORDER BY last_modified DESC LIMIT 1";
                    $rest = $db->query($qry2);
                    $rest->setResultTypes( array('text') );
                    if($rest ==null)
                     return false;
                    while($row =$rest->fetchRow())
                    {
                        $last_modified[] = $row->last_modified;
                    }
                }
            }
            natsort($last_modified);
            $lasttime = array_reverse($last_modified);
            $this->template->setDisplayData( "last_modified", "This record was last modified at ".current($lasttime) );
          }
        parent::action();
      }
      
}
# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
