<?php
/**
* © Copyright 2009 IntraHealth International, Inc.
* 
* This File is part of I2CE 
* 
* I2CE is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License 
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* @package ihris-common
* @author Carl Leitner <litlfred@ibiblio.org>
* @version v3.2
* @since v3.2
* @filesource
*/
/**
* Class iHRIS_Module_PersonDemographic
*
* @access public
*/


class iHRIS_Module_DeployFacility extends I2CE_Module {
  
    public static function getMethods() {
        return array(
            'iHRIS_PageView->action_person_deploy_facility' => 'action_person_deploy_facility'
            );
    }


    public function action_person_deploy_facility($page) {
      if (!$page instanceof iHRIS_PageView) {
          return;
      }
      $person = $page->getPerson();
      if (!$person instanceof iHRIS_Person) {
          return false;
      }
      $template=$page->getTemplate();
      if (  ($lastFac = $this->getLastFacility($person)) instanceof iHRIS_PersonDeployFacility) {
          $person->addChildForm($lastFac);
          $childNode = $page->appendChildTemplate('person_deploy_facility','siteContent');
      } else {
          $childNode = $page->addLastChildForm('person_deploy_facility','deploy_date', 'siteContent');
      }
      if (!array_key_exists('person_deploy_facility',$person->children) || !is_array($person->children['person_deploy_facility']) 
          || count($person->children['person_deploy_facility']) != 1) {
          return true;
      }
      reset($person->children['person_deploy_facility']);        
      $pers_facility = current($person->children['person_deploy_facility']);        
      if ( !$pers_facility instanceof iHRIS_PersonDeployFacility)  {
          return true;
      }
      //$pers_pos->getField( "position" )->setHref( "view_position?id=" );
      return $childNode;
      
      //return $obj->addChildForms('person_deploy_facility', 'siteContent');
    }
    
    /**
     * Find and return the most recent position held by this person.
     * 
     * @return I2CE_Form or null
     */
    public function getLastFacility($person) {
        if (!$person instanceof iHRIS_Person) {
            return null;
        }
        $where = array(
            'operator'=>'FIELD_LIMIT',
            'field'=>'deploy_date',
            'style'=>'not_null'
            );
        $deploy_fac_id = I2CE_FormStorage::search('person_deploy_facility', $person->getNameId(),$where,'-deploy_date');
        if (!$deploy_fac_id) {
            return null;
        }
        $deploy_facility = I2CE_FormFactory::instance()->createContainer('person_deploy_facility'.'|'.current($deploy_fac_id));
        if (!$deploy_facility instanceof iHRIS_PersonPosition) {
            return null;
        }
        $deploy_facility->populate();
        return $deploy_facility;
    }


}
# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
