<?php
/**
* © Copyright 2012 IntraHealth International, Inc.
* 
* This File is part of I2CE 
* 
* I2CE is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License 
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* @package Botswana
* @subpackage 
* @author Carl Leitner <litlfred@ibiblio.org>
* @version v4.1.4.1
* @since v4.1.4.1
* @filesource 
*/ 
/** 
* Class Botswana_Modules_Posts
* 
* @access public
*/


class Botswana_Module_Posts  extends I2CE_Module {


    
    /**
     * Upgrade module method
     */
    public function upgrade($old_vers,$new_vers) {
        if (I2CE_Validate::checkVersion($old_vers,'<','4.1.1.5')) {
            // if (! $this->moveDivisionFromEntryToMagic()) {
            //     return false;
            // }
        }
        return true;
    }


    protected function moveDivisionFromEntryToMagic() {
	if ( ! ($magic_storage = I2CE_FormStorage::getMechanismByStorage('magicdata')) instanceof I2CE_FormStorage_Mechanism) { 
	    I2CE::raiseError("Could not instantiate magicdata form storage");
	    return false;
	}
	if ( ! ($entry_storage = I2CE_FormStorage::getMechanismByStorage('entry')) instanceof I2CE_FormStorage_Mechanism) { 
	    I2CE::raiseError("Could not instantiate entry form storage");
	    return false;
	}
	$user = new I2CE_User();
	if (! I2CE_FormStorage::moveData('dpsm_dept',$entry_storage,$magic_storage,$user)) {
	    I2CE::raiseError("Could not export dpsm_dept to magicdata");
	    return false;
	}
	I2CE::getConfig()->modules->forms->forms->dpsm_dept->storage = "magicdata";
	return true;
    }




}
# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
